#include "config.h"

#if ENABLE_NETSNMP==1
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>


int number1 = 42;


int
handle_number1(netsnmp_mib_handler *handler,
                          netsnmp_handler_registration *reginfo,
                          netsnmp_agent_request_info   *reqinfo,
                          netsnmp_request_info         *requests)
{
    switch(reqinfo->mode) {

        case MODE_GET:
            snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER,
                                     (u_char *) &number1,
                                     sizeof(number1));
            break;

        default:
            return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}


#define NETSNMP_REGISTER_SCALAR(A, B) netsnmp_register_scalar(netsnmp_create_handler_registration(#A, B, A##_oid, OID_LENGTH(A##_oid), HANDLER_CAN_RONLY)); printf("registered: %s\n", #A)

void
init_dhsMIBObjects(void)
{
    static oid dhsNumber1_oid[] = { 1,3,6,1,4,1,9676,2,1,1 };

  DEBUGMSGTL(("dhsMIBObjects", "Initializing\n"));

/*
    netsnmp_register_scalar(
        netsnmp_create_handler_registration("dhsNumber1", handle_number1,
                               dhsNumber1_oid, OID_LENGTH(dhsNumber1_oid),
                               HANDLER_CAN_RONLY
        ));
*/
NETSNMP_REGISTER_SCALAR(dhsNumber1, handle_number1);

}

void snmp_subagent_main () {
  snmp_enable_stderrlog();
  netsnmp_ds_set_boolean(NETSNMP_DS_APPLICATION_ID, NETSNMP_DS_AGENT_ROLE, 1);
  init_agent("smmapd_subagent");
  init_dhsMIBObjects(); 
  init_snmp("smmapd_subagent");

  /* main loop here... */
  while(1) {
printf("*** main loop\n");
    agent_check_and_process(1);
  }

  /* at shutdown time */
  snmp_shutdown("mysubagent");
}
#endif
